/* prcode.c
	for generating listing
*/
#include "sx.h"

#define 	PRIVATE		static

PRIVATE char name[80];		// symbolic name buffer

PRIVATE char opstr[][8] = {
  "Nop","Add","Sub","Mul","Div","Band","Bor","Bxor","Not","Eq",
  "Ne","Lt","Le","Ge","Gt","Shl","Shr","Mod","Ldx","Stx",
  "Ret","Retv","Array","End","Get","Put","Ld","St","Jmp","Jt",
  "Jf","Lit","Call","?","Inc","Dec","Sys","Case","Fun"
};

// if symbol not found, return its ref
PRIVATE char *findName2(int ty, int ref){
	char *nm;
	nm = searchref(ty,ref);
	if( nm == NULL){
		nm = name;
		sprintf(nm,"%d",ref);
	}
	return nm;
}

PRIVATE void pl(FILE *fo, char *s1){
	fprintf(fo,"%s",s1);
}
PRIVATE void pl2(FILE *fo, char *s1, int a){
	fprintf(fo,"%s %d",s1,a);
}
PRIVATE void plnm(FILE *fo, char *s1, char *s2){
	fprintf(fo,"%s %s",s1,s2);
}
void prCode(FILE *fo, int code, int ip){
	int op, a;
	char *s1;
	decode(code,&op,&a);
	s1 = op<=icFun ? opstr[op] : 0;
	switch(op){
	case icArray:
	case icEnd: pl(fo,s1); break;
	case icLd:
	case icSt: plnm(fo,s1,findName2(tyGVAR,a)); break;
	case icJmp:
	case icJt:
	case icJf: pl2(fo,s1,ip+a); break;
	case icCall: plnm(fo,s1,findName2(tyFUN,a)); break;
	case icFun: plnm(fo,s1,findName2(tyFUN,ip)); break;
	default:
		if(op>=icAdd && op<=icStx)
			pl(fo,s1);
		else if(op>=icRet && op<=icSys)
			pl2(fo,s1,a);
		else
			pl(fo,"Undef");
	}
}

